<template>
  <div class="table">
    <div
      class="table_body"
      :style="{overflowY: refreshing ? 'hidden' : null}">
      <div
        class="table_body-inner"
        v-for="(item, key) in data"
        :class="'table_body-inner-'+ getClassType(item.stats)"
        :key="'key-'+key"
      >
        <div class="table-tr flex">
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
        </div>
        <div
          class="table-tr flex flex-middle lastWin"
          @click="details(item)">
          <div class="table-td">
            <div class="lastWin-item_wrapper lastWin_number">
              <div
                class="betNumber"
                v-if="store==='data' || store==='inDays'">
                <div class="betNumber_inner">
                  {{item.win}}
                </div>
              </div>
              <div
                class="dateNumber"
                :class="item.day && (getDay(item.day)==='SAT' || getDay(item.day)==='SUN') ? 'dateNumber-holiday' : ''"
                v-else>
                <div class="dateNumber_inner">
                  <div
                    class="dateNumber_inner-number"
                    v-if="store==='byDays'">{{item.day}}
                  </div>
                  <div class="dateNumber_inner-date">{{store==='byMonth' ? getMonth(item.month) : getDay(item.day)}}</div>
                </div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_bet">
                <div class="color-white">
                  {{item.stats.total.wins.count + item.stats.total.losses.count}}
                </div>
                <div>{{item.stats.total.bets_amount}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_amount">
                <div class="lastWin_color-winAmount">
                  {{item.stats.total.wins.count}}
                </div>
                <div>{{item.stats.total.wins.amount}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_myAmount">
                <div class="lastWin_color-myWinAmount">
                  {{(item.stats.player && item.stats.player.wins.count) || 0}}
                </div>
                <div>{{(item.stats.player && item.stats.player.wins.amount) || 0}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper flex flex-middle flex-center">
              <Btn
                plain
                noPadding>
                <i class="i-icon-more i-deg90 color-icon"></i>
              </Btn>
            </div>
          </div>
        </div>
        <div class="table-tr flex">
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
        </div>
      </div>
      <LoadingLabel v-show="loading"></LoadingLabel>
<!--      <div
        class="table_body-inner pt-10 pb-10 text-center"
        key="loading"
        v-show="loading">{{$t('common.loading')}}-->
      </div>
      <div
        class="scroll_loader-overlay"
        key="refreshing"
        v-show="refreshing">{{$t('common.refreshing')}}
      </div>
    </div>
  </div>
</template>

<script>
  import Btn from '~/components/UI/Btn';
  import {getScrollPercent} from "~/components/utils";
  import debounce from 'lodash.debounce';
  import LoadingLabel from '~/components/UI/LoadingLabel';

  const months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
  const days = ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'];
  export default {
    name: "HistoryFullBody",
    props: {
      allGames: Boolean,
      wins: Boolean,
      my: Boolean,
      calendarOpened: Boolean,
      store: {
        type: String,
        default: 'data'
      }
    },
    data() {
      return {
        limit: 20,
        offset: 0,
        page: 1,
        loading: false,
        refreshing: false,
        day: '',
        lastScrollY: 0,
        gq: () => {
        },
      }
    },
    computed: {
      data() {
        return this.$store.state.game[this.store];
      }
    },
    components: {
      Btn,
      LoadingLabel
    },
    methods: {
      clearScrollState() {
        this.page = 1;
        this.lastScrollY = 0;
      },
      details(item) {
        this.$emit('changeData', item);
        this.ga('yech', true);
      },
      getDay(number) {
        const day = new Date(new Date().getFullYear(), this.currentMonth, number).getDay();
        return days[day];
      },
      getMonth(number) {
        return months[number - 1];
      },
      getClassType(stats) {
        let type = '3';
        if (stats.total.losses.count && !stats.total.wins.count) type = '4';
        if (stats.player && stats.player.wins.count) type = '2';
        if (stats.player && !stats.player.wins.count && stats.player.losses.count && !this.$store.state.game.filters.wins) type = '1';
        if ((stats.player && !stats.player.wins.count && !stats.player.losses.count || !stats.player) && stats.total.wins.count) type = '0';
        if ((stats.player && !stats.player.wins.count && stats.player.losses.count || !stats.player) && stats.total.wins.count && this.$store.state.game.filters.wins) type = '0';
        return type;
      },
      showDetails(item) {
        this.$store.commit('gameDetails/CLEAN_DETAILS');
        this.$nextTick(async _ => {
          this.$store.commit('gameDetails/SET_HISTORY_GAME_SETTINGS', item);
          //TODO remove after backend refactor
          localStorage.getItem('accountname') && this.$store.dispatch('gameDetails/fetch', {
            hash: item.house_seed_hash,
            type: 'my'
          });
          await this.$store.dispatch('gameDetails/fetch', {
            hash: item.house_seed_hash,
            type: 'others'
          });
          this.$store.commit('gameDetails/SET_SHOWING', true);
        });
      },
      getDataByYear() {
        return new Promise((resolve, reject) => {
          this.loading = true;
          this.$store.dispatch('game/fetchFullGames', {
            year: new Date().getFullYear(),
            flush: this.page === 1,
            field: this.store
          }).then(_ => {
            this.loading = false;
            this.refreshing = false;
            resolve();
          }).catch(_ => {
            this.loading = false;
            this.refreshing = false;
            reject();
          });
        })
      },
      getDataByMonth({year, month}) {
        return new Promise((resolve, reject) => {
          this.loading = true;
          this.$store.commit(`game/SET_DATA`, {
            field: 'byDays',
            value: []
          });
          this.$store.dispatch('game/fetchFullGames', {
            month: `${year.toString().slice(2)}/${month}`,
            flush: this.page === 1,
            field: 'byDays'
          }).then(res => {
            this.loading = false;
            this.refreshing = false;
            resolve();
          }).catch(e => {
            this.loading = false;
            this.refreshing = false;
            reject();
          });
        })
      },
      getData() {
        return new Promise((resolve) => {
          this.loading = true;
          this.$store.dispatch('game/fetchFullGames', {
            offset: this.limit * (this.page - 1),
            flush: this.page === 1,
            limit: this.limit,
            day: this.day,
            restoreData: false,
            field: this.day ? 'inDays' : this.store
          }).then(res => {
            this.loading = false;
            this.refreshing = false;
          }).catch(e => {
            this.loading = false;
            this.refreshing = false;
          }).finally(_ => {
            resolve();
          });
        })
      },
    },
    mounted() {
      this.gq = debounce(this.getData, 800);
      this.$onWrapperScroll.flush();
      this.$onWrapperScroll.onScroll((e) => {
        if (this.store !== 'byDays' && this.store !== 'byMonth' && getScrollPercent(this.$onWrapperScroll.container) > 80 && e.target.scrollTop > this.lastScrollY && !this.loading) {
          this.lastScrollY = e.target.scrollTop;
          this.loading = true;
          this.page += 1;
          this.$nextTick(_ => {
            this.gq();
          });
        }
      });
    }
  }
</script>
